/*
 TECNISA - TECNOLOGIA EM INFORMTICA

 NOME: GERA_BOLETOS

 DESCRIO:
 PROCEDIMENTO PARA GERAO DOS BOLETOS E RATEIO DOS VALORES DE IMPOSTOS
 COM TRATAMENTO PARA RETER NA FONTE COM AJUSTE NO BOLETO.

 CRIAO:
 10/08/2000 - ROBERTO A. LOPES MARTINS

 CHAMADA PARA CRIAO
 @C:\WIN_PRJ\SQL\SQLSERVER\1015_FINSTP_GERA_BOLETOS
 */

IF EXISTS (SELECT
              *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE
	           O.NAME = 'GERA_BOLETOS' AND
	           TYPE = 'P' 			     AND
              U.UID = O.UID           AND
              U.NAME = USER)

DROP PROCEDURE GERA_BOLETOS
GO

CREATE PROCEDURE GERA_BOLETOS
    @P_CDFILIAL    VARCHAR(04),
    @P_NRLANCTONF  VARCHAR(10),
    @P_CDFILILANC  VARCHAR(04),
    @P_NRLANBOLREC VARCHAR(10),
    @P_CDTPCTRECEB VARCHAR(06),
    @P_IDEXCBOLREC VARCHAR(01) = 'N',
    @P_CDFILBOLORI VARCHAR(04) = NULL,
    @P_NRLANBOLORI VARCHAR(10) = NULL

AS

   DECLARE @V_CDCLIENTE   VARCHAR(21);
   DECLARE @V_CDEMPRESA   VARCHAR(02);
   DECLARE @V_CDFILIEMIT  VARCHAR(04);
   DECLARE @V_VRPEMULBREC NUMERIC(10,3);
   DECLARE @V_VRPEMORBREC NUMERIC(10,3);

   DECLARE @V_CDSERIE     VARCHAR(05);
   DECLARE @V_NRNOTAFISC  VARCHAR(10);
   DECLARE @V_NRINSJURNF  VARCHAR(20);
   DECLARE @V_IDSISTEMA   VARCHAR(03);
   
   DECLARE @V_CDCLASSFINA VARCHAR(06);
   DECLARE @V_CDCLASSAJUS VARCHAR(06);
   DECLARE @V_NRLANBOLREC VARCHAR(10);
   DECLARE @V_NRLANBOLAUX VARCHAR(10);


   DECLARE @V_VRPARCELAS  FLOAT;
   DECLARE @V_NRPARCELAS  FLOAT;
   DECLARE @V_NRCONTADOR  FLOAT;
   DECLARE @V_VRTOTACONT  NUMERIC(16,2);
   DECLARE @V_VRACUMULADO NUMERIC(16,2);
   DECLARE @V_VRAJUSTEBO  NUMERIC(16,2);

   DECLARE @V_CDFIMFLUXO  VARCHAR(04);
   DECLARE @V_NRREGFOR    INTEGER;

   DECLARE @V_CDCONTREDUGB VARCHAR(03);
   DECLARE @V_CDTPBAIXAREC VARCHAR(02);
   DECLARE @V_DTVENBOLREC  DATETIME;
   DECLARE @V_CDFILIAL     VARCHAR(4);

   DECLARE @V_CDBANCO      VARCHAR(03);
   DECLARE @V_IDPRIORBPREF VARCHAR(01);
   DECLARE @V_QTDIAPRORCNT NUMERIC(15);
   DECLARE @V_IDCOFERIBANC VARCHAR(01);
   DECLARE @DATAVENCCTAREC DATETIME;
   DECLARE @V_CDTIPORECE   VARCHAR(03);
   DECLARE @V_NRLANCCONT   VARCHAR(12);
   DECLARE @V_NRSEQLANC    VARCHAR(5);

   /* VARIVEIS DO CURSOR C_CNTREC */
   DECLARE @V_CNTREC_NRSEQVENREC  VARCHAR(02);
   DECLARE @V_CNTREC_DTATUAVENREC DATETIME;
   DECLARE @V_CNTREC_DTORIGVENREC DATETIME;
   DECLARE @V_CNTREC_VRATUAREC    NUMERIC(16,2);
   DECLARE @V_CNTREC_CDFILIBOLREC VARCHAR(04);
   DECLARE @V_CNTREC_NRLANBOLREC  VARCHAR(10);
   DECLARE @V_CNTREC_CDEMPRESA    VARCHAR(02);
   DECLARE @V_CNTREC_CDFIMOVFLREC VARCHAR(04);
   DECLARE @V_CNTREC_DTMOVFLUXO   DATETIME;
   DECLARE @V_CNTREC_IDMOVFLUXO   VARCHAR(01);
   DECLARE @V_CNTREC_CDCLASSFINA  VARCHAR(06);
   DECLARE @V_CNTREC_VRORIGREC    NUMERIC(16,2);
   DECLARE @V_CNTREC_NRPARCELAREC VARCHAR(02);
   DECLARE @V_CNTREC_IDSTATREC    VARCHAR(01);
   DECLARE @V_CNTREC_NRLANCTODUP  VARCHAR(10);

   /* VARIVEIS DO CURSOR C_FERIBC */
   DECLARE @V_FERIBC_DTFERIBANC   DATETIME;

   /* VARIVEIS DO CURSOR C_AJUSTECNT */
   DECLARE @V_AJUSTECNT_CDFILIAL     VARCHAR(04);
   DECLARE @V_AJUSTECNT_NRLANCTONF   VARCHAR(10);
   DECLARE @V_AJUSTECNT_NRSEQVENREC  VARCHAR(02);
   DECLARE @V_AJUSTECNT_NRPARCELAREC VARCHAR(02);
   DECLARE @V_AJUSTECNT_DTAJUSTEREC  DATETIME;
   DECLARE @V_AJUSTECNT_CDAJUCTREC   VARCHAR(02);
   DECLARE @V_AJUSTECNT_CDCLASSFINA  VARCHAR(06);
   DECLARE @V_AJUSTECNT_CDEMMFAJCNTR VARCHAR(02);
   DECLARE @V_AJUSTECNT_CDFIMFAJCNTR VARCHAR(04);
   DECLARE @V_AJUSTECNT_DTMOVFLUXO   DATETIME;
   DECLARE @V_AJUSTECNT_IDMOVFLUXO   VARCHAR(01);
   DECLARE @V_AJUSTECNT_VRAJUSTEREC  NUMERIC(16,2);
   DECLARE @V_AJUSTECNT_IDAJUCTREC   VARCHAR(01);

   /* VARIVEIS DO CURSOR C_RATTPCTR */
   DECLARE @V_RATTPCTR_CDTPCTRECEB  VARCHAR(06);
   DECLARE @V_RATTPCTR_CDCENTCUST   VARCHAR(04);
   DECLARE @V_RATTPCTR_CDFILIAL     VARCHAR(04);
   DECLARE @V_RATTPCTR_CDFIRATTPCTR VARCHAR(04);
   DECLARE @V_RATTPCTR_VRPERATTPCTR NUMERIC(15,2);

   /* VARIVEIS DO CURSOR C_AJUSTE */
   DECLARE @V_AJUSTE_VRTOTIMPONF NUMERIC(15,2);
   DECLARE @V_AJUSTE_CDAJUCTREC  VARCHAR(02);

   DECLARE @V_MULT               NUMERIC(16,2);

   DECLARE @V_CDCARTCOBR      VARCHAR(03);
   DECLARE @V_IDCARTCOBR      VARCHAR(01);
   DECLARE @V_IDIMPRBOLETO    VARCHAR(01);
   DECLARE @V_QTDIAPROTEST    NUMERIC(11);
   DECLARE @V_CDDIAPROTEST    VARCHAR(01);   
   DECLARE @V_CDINS1COBR_1    VARCHAR(02);
   DECLARE @V_CDINS2COBR_1    VARCHAR(02);

   DECLARE @V_CDINS1COBR  VARCHAR(02);
   DECLARE @V_CDINS2COBR  VARCHAR(02);
BEGIN
   SELECT @V_CDCLIENTE = N.CDCLIENTE, @V_CDEMPRESA = N.CDEMPRESA,
          @V_CDFILIEMIT = N.CDFILIEMIT, @V_CDSERIE = N.CDSERIE,
          @V_NRNOTAFISC = N.NRNOTAFISC, @V_NRINSJURNF = N.NRINSJURNF,
          @V_VRPEMULBREC = ISNULL(C.VRPEMULBCLI, VRPEMULEMPR),
          @V_VRPEMORBREC = ISNULL(C.VRPEMORBCLI, E.VRPEMOREMPR),
          @V_IDSISTEMA   = N.IDSISTEMA, @V_NRLANCCONT = N.NRLANCTBDOC
   FROM NOTAFISCAL N LEFT JOIN CLIENTE C ON
        (N.CDCLIENTE = C.CDCLIENTE),
        EMPRESA E
   WHERE N.CDFILIAL   = @P_CDFILIAL    AND
         N.NRLANCTONF = @P_NRLANCTONF  AND
         N.CDEMPRESA  = E.CDEMPRESA;

   SELECT @V_CDCLASSFINA = MAX(CDCLASSFINA)
   FROM TIPOCTRECEBER
   WHERE CDTPCTRECEB = @P_CDTPCTRECEB;

   IF (@P_CDFILBOLORI IS NULL) AND (@P_NRLANBOLORI IS NULL) BEGIN
      SELECT @V_CDCONTREDUGB = MAX(BF.CDREDUCONT), @V_IDPRIORBPREF = MAX(BF.IDPRIORBPREF),
             @V_CDINS1COBR = MAX(BF.CDINS1COBRCL), @V_CDINS2COBR = MAX(BF.CDINS2COBRCL),
             @V_CDBANCO = MAX(BF.CDBANCO)
      FROM BANCOPREF BF, CONTCORR  CC
      WHERE
         (CC.CDEMPRESA    = @V_CDEMPRESA  ) AND
         (CC.CDREDUCONT   = BF.CDREDUCONT) AND
         (BF.CDCLIENTE    = @V_CDCLIENTE ) AND
         (BF.IDPRIORBPREF = 'S');

      IF (NOT @V_CDBANCO IS NULL) BEGIN
         SELECT @V_QTDIAPRORCNT = MAX(QTDIAPRORCNT)
         FROM BANCO
         WHERE (CDBANCO = @V_CDBANCO);

         SELECT @V_IDCOFERIBANC = MAX(IDCOFERIBANC)
         FROM PARAMGERAL;
      END;
   END;

   SELECT @V_CDTPBAIXAREC = MAX(CDTPBAIXAREC)
   FROM PARAMFILIAL
   WHERE
      (CDFILIAL = (SELECT CDFILIEMIT
                   FROM NOTAFISCAL
                   WHERE
                      CDFILIAL   = @P_CDFILIAL AND
                      NRLANCTONF = @P_NRLANCTONF));

   IF @V_CDCONTREDUGB IS NULL BEGIN
      SELECT @V_CDCONTREDUGB = MAX(CDREDUGBFILI)
      FROM PARAMFILIAL
      WHERE
         (CDFILIAL = (SELECT CDFILIEMIT
                      FROM NOTAFISCAL
                      WHERE
                         CDFILIAL   = @P_CDFILIAL AND
                         NRLANCTONF = @P_NRLANCTONF));
      IF NOT @V_CDCONTREDUGB IS NULL BEGIN
         SET @V_CDINS1COBR = NULL;
         SET @V_CDINS2COBR = NULL;
         SELECT @V_CDCONTREDUGB = MAX(CC.CDREDUCONT)
         FROM CONTCORR CC, FILIAL FI
         WHERE
            (CC.CDEMPRESA  = FI.CDEMPRESA) AND
            (FI.CDFILIAL   = @V_CDFILIAL)   AND
            (CC.CDREDUCONT = @V_CDCONTREDUGB);
      END;
   END;

   IF @V_CDCONTREDUGB IS NULL BEGIN
     SELECT V_CDCONTREDUGB = MAX(P.CDREDUGBEMPR)
      FROM PARAMEMPRESA P
      WHERE (P.CDEMPRESA = @V_CDEMPRESA);
   END;

   IF NOT @V_CDCONTREDUGB IS NULL BEGIN
      SELECT @V_CDINS1COBR_1 = MAX(E.CDINS1COBR),
             @V_CDINS2COBR_1 = MAX(E.CDINS2COBR),
             @V_CDCARTCOBR   = MAX(E.CDCARTCOBR),
             @V_IDCARTCOBR   = MAX(E.IDCARTCOBR),
             @V_IDIMPRBOLETO = MAX(E.IDIMPRBOLETO),
             @V_QTDIAPROTEST = MAX(E.QTDIAPROTEST),
             @V_CDDIAPROTEST = MAX(E.CDDIAPROTEST)
      FROM EMPRBANC E, CONTCORR C
      WHERE (E.CDEMPRESA  = @V_CDEMPRESA) AND
            (E.CDBANCO    = C.CDBANCO)   AND
            (C.CDREDUCONT = @V_CDCONTREDUGB);

      IF @V_CDINS1COBR IS NULL AND
         @V_CDINS2COBR IS NULL BEGIN
         SET @V_CDINS1COBR = @V_CDINS1COBR_1;
         SET @V_CDINS2COBR = @V_CDINS2COBR_1;
      END;
   END;

   IF @V_CDTPBAIXAREC IS NULL BEGIN
      SELECT @V_CDTPBAIXAREC = MAX(CDTPBAIXAREC)
      FROM PARAMEMPRESA
      WHERE (CDEMPRESA = @V_CDEMPRESA);
   END;

   IF ((@V_IDSISTEMA = 'PED') OR (@V_IDSISTEMA = 'EXP')) BEGIN
      SELECT DISTINCT @V_CDTIPORECE = MAX(MO.CDTIPORECE)
      FROM PEDIDO PE, ITEMPRODUTO IP, MODPGTO MO
      WHERE MO.CDMODPGTO   = PE.CDMODPGTO AND
            IP.CDFILIALPED = PE.CDFILIAL  AND
            IP.NRPEDIDO    = PE.NRPEDIDO  AND
            IP.CDFILIAL    = @P_CDFILIAL  AND
            IP.NRLANCTONF  = @P_NRLANCTONF;
   END;

   
   SET @V_NRPARCELAS = 0;
   SET @V_NRLANBOLREC = @P_NRLANBOLREC;

   DECLARE C_CNTREC CURSOR FOR
   SELECT C.NRSEQVENREC, C.DTATUAVENREC, C.DTORIGVENREC,
          C.VRATUAREC, C.CDFILIBOLREC, C.NRLANBOLREC,
          C.CDEMPRESA, C.CDFIMOVFLREC, C.DTMOVFLUXO,
          C.IDMOVFLUXO, C.CDCLASSFINA, C.VRORIGREC,
          C.NRPARCELAREC, C.IDSTATREC
   FROM CONTARECEBER C LEFT JOIN DUPLICATA D ON
        (C.CDFILIALDUP = D.CDFILIAL) AND
        (C.NRLANCTODUP = D.NRLANCTODUP)
   WHERE C.CDFILIAL    = @P_CDFILIAL       AND
         C.NRLANCTONF  = @P_NRLANCTONF     AND
         (C.NRLANCTODUP IS NULL OR D.CDINTEGDUP IS NOT NULL)
   ORDER BY NRSEQVENREC;

   OPEN C_CNTREC;

   FETCH NEXT FROM C_CNTREC INTO @V_CNTREC_NRSEQVENREC, @V_CNTREC_DTATUAVENREC,
                                 @V_CNTREC_DTORIGVENREC, @V_CNTREC_VRATUAREC,
                                 @V_CNTREC_CDFILIBOLREC, @V_CNTREC_NRLANBOLREC,
                                 @V_CNTREC_CDEMPRESA, @V_CNTREC_CDFIMOVFLREC,
                                 @V_CNTREC_DTMOVFLUXO, @V_CNTREC_IDMOVFLUXO,
                                 @V_CNTREC_CDCLASSFINA, @V_CNTREC_VRORIGREC,
                                 @V_CNTREC_NRPARCELAREC, @V_CNTREC_IDSTATREC;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF (@P_CDFILBOLORI IS NULL AND @P_NRLANBOLORI IS NULL) OR
         (@V_CNTREC_CDFILIBOLREC = @P_CDFILBOLORI AND @V_CNTREC_NRLANBOLREC = @P_NRLANBOLORI) BEGIN

         IF (@P_CDFILBOLORI IS NULL) AND (@P_NRLANBOLORI IS NULL) BEGIN
            IF (NOT @V_CDBANCO IS NULL) BEGIN
               SET @DATAVENCCTAREC = @V_CNTREC_DTATUAVENREC;
               SET @V_CNTREC_DTATUAVENREC = @V_CNTREC_DTORIGVENREC;
               IF (NOT @V_QTDIAPRORCNT IS NULL) BEGIN
                  SET @V_CNTREC_DTATUAVENREC = @V_CNTREC_DTATUAVENREC + @V_QTDIAPRORCNT;
               END;
               IF @V_IDCOFERIBANC = 'S' BEGIN
                  DECLARE C_FERIBC CURSOR FOR
                  SELECT DTFERIBANC
                  FROM FERIBANC
                  WHERE
                     (CDFILIAL = @P_CDFILIAL) AND
                     (DTFERIBANC >= @V_CNTREC_DTATUAVENREC);

                  OPEN C_FERIBC;

                  FETCH NEXT FROM C_FERIBC INTO @V_FERIBC_DTFERIBANC;

                  WHILE (@@FETCH_STATUS = 0) BEGIN

                     IF @V_FERIBC_DTFERIBANC = @V_CNTREC_DTATUAVENREC BEGIN
                        SET @V_CNTREC_DTATUAVENREC = @V_CNTREC_DTATUAVENREC + 1;
                     END
                     ELSE BEGIN
                        RETURN;
                     END;
                     FETCH NEXT FROM C_FERIBC INTO @V_FERIBC_DTFERIBANC;
                  END;
                  CLOSE C_FERIBC;
                  DEALLOCATE C_FERIBC;
               END;
            END;
         END;

         IF @P_IDEXCBOLREC = 'S' BEGIN
            /* - NA EXCLUSO DA DUPLICATA VOLTA TODOS OS VENCIMENTOS PARA DATA ORIGINAL - */
            SET @V_DTVENBOLREC = @V_CNTREC_DTORIGVENREC;
         END
         ELSE BEGIN
            SET @V_DTVENBOLREC = @V_CNTREC_DTATUAVENREC;
         END;

         SET @V_NRLANBOLAUX = @V_NRLANBOLREC;
         IF ((@V_IDSISTEMA = 'PDV') AND (@V_CNTREC_IDSTATREC = 'P')) BEGIN
            SET @V_NRLANBOLREC = @V_CNTREC_NRLANBOLREC;
            UPDATE BOLETRECEBER
            SET VRBOLREC     = @V_CNTREC_VRATUAREC,
                VRFINALBREC  = @V_CNTREC_VRATUAREC,
                DTVENBOLREC  = @V_DTVENBOLREC,
                VRPEMULBREC  = @V_VRPEMULBREC,
                VRMULTABREC  = 0,
                VRPEMORBREC  = @V_VRPEMORBREC,
                VRMORDIABREC = 0,
                CDINS1COBBOL = @V_CDINS1COBR,
                CDINS2COBBOL = @V_CDINS2COBR,
                CDCARTCOBBOL = @V_CDCARTCOBR,
                IDCARTCOBREC = @V_IDCARTCOBR,
                IDIMPRBOLBOL = @V_IDIMPRBOLETO,
                QTDIAPROTBOL = @V_QTDIAPROTEST,
                CDDIAPROTBOL = @V_CDDIAPROTEST
            WHERE
               CDFILIAL    = @P_CDFILILANC AND
               NRLANBOLREC = @V_NRLANBOLREC;
         END
         ELSE BEGIN
            INSERT INTO BOLETRECEBER
               (CDFILIAL,     NRLANBOLREC, CDCLIENTE,   CDEMPRESA,
                VRBOLREC,     VRFINALBREC, DTVENBOLREC, CDTPBAIXAREC,
                IDSTATBREC,   VRPEMULBREC, VRMULTABREC, VRPEMORBREC,
                VRMORDIABREC, CDREDUCONT, CDINS1COBBOL, CDINS2COBBOL,
                CDCARTCOBBOL, IDCARTCOBREC, IDIMPRBOLBOL, QTDIAPROTBOL, CDDIAPROTBOL)
            VALUES
               (@P_CDFILILANC, @V_NRLANBOLREC, @V_CDCLIENTE, @V_CDEMPRESA,
                @V_CNTREC_VRATUAREC, @V_CNTREC_VRATUAREC, @V_DTVENBOLREC, @V_CDTPBAIXAREC,
                'A', @V_VRPEMULBREC, 0, @V_VRPEMORBREC, 0, @V_CDCONTREDUGB, @V_CDINS1COBR,
                @V_CDINS2COBR, @V_CDCARTCOBR, @V_IDCARTCOBR, @V_IDIMPRBOLETO, @V_QTDIAPROTEST, @V_CDDIAPROTEST);
         END;

         IF (NOT @V_CDTIPORECE IS NULL) BEGIN
            INSERT INTO TPRECBOLETO
               (CDFILIAL,   NRLANBOLREC, NRSEQTPRECBO,
                CDTIPORECE, VRTPRECBOLR)
            VALUES
               (@P_CDFILILANC, @V_NRLANBOLREC, '01',
                @V_CDTIPORECE, @V_CNTREC_VRATUAREC);
         END;

         /* - VERIFICA SE O PROCEDURE EST SENDO CHAMADA DA PROCEDURE DE EXCLUSO DE DUPLICATA - */
         IF @P_IDEXCBOLREC = 'S' BEGIN
            IF @V_CNTREC_DTORIGVENREC <> @V_CNTREC_DTATUAVENREC BEGIN
               /* - ATUALIZA O FLUXO DE CAIXA -------------------------- */
               SET @V_MULT = @V_CNTREC_VRORIGREC * -1;
               EXEC ATUALIZA_FLUXO_DE_CAIXA @V_CNTREC_CDEMPRESA,
                                            @V_CNTREC_CDFIMOVFLREC,
                                            @V_CNTREC_DTMOVFLUXO,
                                            @V_CNTREC_IDMOVFLUXO,
                                            @V_CNTREC_CDCLASSFINA,
                                            @V_MULT,
                                            0;

               EXEC ATUALIZA_FLUXO_DE_CAIXA @V_CNTREC_CDEMPRESA,
                                            @V_CNTREC_CDFIMOVFLREC,
                                            @V_CNTREC_DTORIGVENREC,
                                            @V_CNTREC_IDMOVFLUXO,
                                            @V_CNTREC_CDCLASSFINA,
                                            @V_CNTREC_VRORIGREC,
                                            0;

               /* -- ATUALIZA O FLUXO DE CAIXA DOS AJUSTES DA CONTA -------------*/
               SELECT
                  @V_NRREGFOR = COUNT(*)
               FROM
                  AJCTRECEBER
               WHERE
                  (CDFILIAL     = @P_CDFILIAL)           AND
                  (NRLANCTONF   = @P_NRLANCTONF)         AND
                  (NRSEQVENREC  = @V_CNTREC_NRSEQVENREC) AND
                  (NRPARCELAREC = @V_CNTREC_NRPARCELAREC);

               IF @V_NRREGFOR > 0 BEGIN
                  DECLARE C_AJUSTECNT CURSOR FOR
                  SELECT
                     AJ.CDFILIAL, AJ.NRLANCTONF, AJ.NRSEQVENREC,
                     AJ.NRPARCELAREC, AJ.DTAJUSTEREC, AJ.CDAJUCTREC,
                     AJ.CDCLASSFINA, AJ.CDEMMFAJCNTR, AJ.CDFIMFAJCNTR,
                     AJ.DTMOVFLUXO, AJ.IDMOVFLUXO, AJ.VRAJUSTEREC, TA.IDAJUCTREC
                  FROM
                     AJCTRECEBER   AJ,
                     TIPOAJRECEBER TA
                  WHERE
                     (AJ.CDFILIAL     = @P_CDFILIAL)            AND
                     (AJ.NRLANCTONF   = @P_NRLANCTONF)          AND
                     (AJ.NRSEQVENREC  = @V_CNTREC_NRSEQVENREC)  AND
                     (AJ.NRPARCELAREC = @V_CNTREC_NRPARCELAREC) AND
                     (TA.CDAJUCTREC   = AJ.CDAJUCTREC);

                  OPEN C_AJUSTECNT;

                  FETCH NEXT FROM C_AJUSTECNT INTO @V_AJUSTECNT_CDFILIAL, @V_AJUSTECNT_NRLANCTONF,
                                                   @V_AJUSTECNT_NRSEQVENREC, @V_AJUSTECNT_NRPARCELAREC,
                                                   @V_AJUSTECNT_DTAJUSTEREC, @V_AJUSTECNT_CDAJUCTREC,
                                                   @V_AJUSTECNT_CDCLASSFINA, @V_AJUSTECNT_CDEMMFAJCNTR,
                                                   @V_AJUSTECNT_CDFIMFAJCNTR, @V_AJUSTECNT_DTMOVFLUXO,
                                                   @V_AJUSTECNT_IDMOVFLUXO, @V_AJUSTECNT_VRAJUSTEREC,
                                                   @V_AJUSTECNT_IDAJUCTREC;

                  WHILE (@@FETCH_STATUS = 0) BEGIN

                     IF @V_AJUSTECNT_IDAJUCTREC = 'A' BEGIN
                        SET @V_MULT = @V_AJUSTECNT_VRAJUSTEREC * -1;
                        EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJUSTECNT_CDEMMFAJCNTR,
                                                     @V_AJUSTECNT_CDFIMFAJCNTR,
                                                     @V_AJUSTECNT_DTMOVFLUXO,
                                                     @V_AJUSTECNT_IDMOVFLUXO,
                                                     @V_AJUSTECNT_CDCLASSFINA,
                                                     @V_MULT,
                                                     0;

                        EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJUSTECNT_CDEMMFAJCNTR,
                                                     @V_AJUSTECNT_CDFIMFAJCNTR,
                                                     @V_CNTREC_DTORIGVENREC,
                                                     @V_AJUSTECNT_IDMOVFLUXO,
                                                     @V_AJUSTECNT_CDCLASSFINA,
                                                     @V_AJUSTECNT_VRAJUSTEREC,
                                                     0;
                     END
                     ELSE BEGIN
                        EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJUSTECNT_CDEMMFAJCNTR,
                                                     @V_AJUSTECNT_CDFIMFAJCNTR,
                                                     @V_AJUSTECNT_DTMOVFLUXO,
                                                     @V_AJUSTECNT_IDMOVFLUXO,
                                                     @V_AJUSTECNT_CDCLASSFINA,
                                                     @V_AJUSTECNT_VRAJUSTEREC,
                                                     0;

                        SET @V_MULT = @V_AJUSTECNT_VRAJUSTEREC * -1;
                        EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJUSTECNT_CDEMMFAJCNTR,
                                                     @V_AJUSTECNT_CDFIMFAJCNTR,
                                                     @V_CNTREC_DTORIGVENREC,
                                                     @V_AJUSTECNT_IDMOVFLUXO,
                                                     @V_AJUSTECNT_CDCLASSFINA,
                                                     @V_MULT,
                                                     0;
                     END;

                     /* -- ALTERA A CHAVE DO MOVIMENTO DO FLUXO -------------*/
                     UPDATE AJCTRECEBER
                     SET DTMOVFLUXO = @V_CNTREC_DTORIGVENREC
                     WHERE
                        (CDFILIAL     = @V_AJUSTECNT_CDFILIAL)     AND
                        (NRLANCTONF   = @V_AJUSTECNT_NRLANCTONF)   AND
                        (NRSEQVENREC  = @V_AJUSTECNT_NRSEQVENREC)  AND
                        (NRPARCELAREC = @V_AJUSTECNT_NRPARCELAREC) AND
                        (DTAJUSTEREC  = @V_AJUSTECNT_DTAJUSTEREC)  AND
                        (CDAJUCTREC   = @V_AJUSTECNT_CDAJUCTREC)   AND
                        (CDCLASSFINA  = @V_AJUSTECNT_CDCLASSFINA);

                     FETCH NEXT FROM C_AJUSTECNT INTO @V_AJUSTECNT_CDFILIAL, @V_AJUSTECNT_NRLANCTONF,
                                                      @V_AJUSTECNT_NRSEQVENREC, @V_AJUSTECNT_NRPARCELAREC,
                                                      @V_AJUSTECNT_DTAJUSTEREC, @V_AJUSTECNT_CDAJUCTREC,
                                                      @V_AJUSTECNT_CDCLASSFINA, @V_AJUSTECNT_CDEMMFAJCNTR,
                                                      @V_AJUSTECNT_CDFIMFAJCNTR, @V_AJUSTECNT_DTMOVFLUXO,
                                                      @V_AJUSTECNT_IDMOVFLUXO, @V_AJUSTECNT_VRAJUSTEREC,
                                                      @V_AJUSTECNT_IDAJUCTREC;

                  END;
                  CLOSE C_AJUSTECNT;
                  DEALLOCATE C_AJUSTECNT;
               END;
            END;

            /* -- ALTERA A CHAVE DO MOVIMENTO DO FLUXO E DO BOLETO-------------*/
            UPDATE CONTARECEBER
            SET CDFILIBOLREC   = @P_CDFILILANC,
                NRLANBOLREC    = @V_NRLANBOLREC,
                DTATUAVENREC   = @V_CNTREC_DTORIGVENREC,
                CDMOTIPROR     = NULL,
                DTMOVFLUXO     = @V_CNTREC_DTORIGVENREC
            WHERE CDFILIAL     = @P_CDFILIAL           AND
                  NRLANCTONF   = @P_NRLANCTONF         AND
                  NRSEQVENREC  = @V_CNTREC_NRSEQVENREC AND
                  NRPARCELAREC = @V_CNTREC_NRPARCELAREC;
         END
         ELSE BEGIN
            /* ------  CASO O CLIENTE UTILIZE UM BANCO PREFERENCIAL ----  */
            IF (NOT @V_CDBANCO IS NULL) BEGIN
               /* - ATUALIZA O FLUXO DE CAIXA -------------------------- */
               SET @V_MULT = @V_CNTREC_VRORIGREC * -1;
               EXEC ATUALIZA_FLUXO_DE_CAIXA @V_CDEMPRESA,
                                            @V_CDFILIEMIT,
                                            @DATAVENCCTAREC,
                                            'E',
                                            @V_CDCLASSFINA,
                                            @V_MULT,
                                            0;

               EXEC ATUALIZA_FLUXO_DE_CAIXA @V_CDEMPRESA,
                                            @V_CDFILIEMIT,
                                            @V_CNTREC_DTATUAVENREC,
                                            'E',
                                            @V_CDCLASSFINA,
                                            @V_CNTREC_VRORIGREC,
                                            0;

               UPDATE CONTARECEBER
               SET CDTPCTRECEB    = @P_CDTPCTRECEB,
                   CDFILIBOLREC   = @P_CDFILILANC,
                   NRLANBOLREC    = @V_NRLANBOLREC,
                   DTATUAVENREC   = @V_CNTREC_DTATUAVENREC,
                   CDCLASSFINA    = @V_CDCLASSFINA,
                   CDEMPRESA      = @V_CDEMPRESA,
                   CDFIMOVFLREC   = @V_CDFILIEMIT,
                   DTMOVFLUXO     = @V_CNTREC_DTATUAVENREC,
                   IDMOVFLUXO     = 'E',
                   DSCONTAREC     = SUBSTRING(ISNULL(DSCONTAREC,'NF: '+@V_NRINSJURNF+' - '+@V_NRNOTAFISC+' - '+@V_CDSERIE),1,100)
               WHERE CDFILIAL     = @P_CDFILIAL           AND
                     NRLANCTONF   = @P_NRLANCTONF         AND
                     NRSEQVENREC  = @V_CNTREC_NRSEQVENREC AND
                     NRPARCELAREC = @V_CNTREC_NRPARCELAREC;
            END
            ELSE BEGIN
               UPDATE CONTARECEBER
               SET CDTPCTRECEB    = @P_CDTPCTRECEB,
                   CDFILIBOLREC   = @P_CDFILILANC,
                   NRLANBOLREC    = @V_NRLANBOLREC,
                   CDCLASSFINA    = @V_CDCLASSFINA,
                   CDEMPRESA      = @V_CDEMPRESA,
                   CDFIMOVFLREC   = @V_CDFILIEMIT,
                   DTMOVFLUXO     = @V_CNTREC_DTATUAVENREC,
                   IDMOVFLUXO     = 'E',
                   DSCONTAREC     = SUBSTRING(ISNULL(DSCONTAREC,'NF: '+@V_NRINSJURNF+' - '+@V_NRNOTAFISC+' - '+@V_CDSERIE),1,100)
               WHERE CDFILIAL     = @P_CDFILIAL           AND
                     NRLANCTONF   = @P_NRLANCTONF         AND
                     NRSEQVENREC  = @V_CNTREC_NRSEQVENREC AND
                     NRPARCELAREC = @V_CNTREC_NRPARCELAREC;

            END;

            DELETE FROM RATCTRECEBER
            WHERE CDFILIAL    = @P_CDFILIAL   AND
                  NRLANCTONF  = @P_NRLANCTONF AND
                  NRSEQVENREC = @V_CNTREC_NRSEQVENREC;

            SET @V_NRCONTADOR = 1;
            SET @V_VRACUMULADO = 0;

            SELECT @V_NRSEQLANC = MAX(NRSEQLANC)
            FROM LANCCONT
            WHERE CDEMPRESA   = @V_CDEMPRESA    AND
                  NRLANCCONT  = @V_NRLANCCONT   AND
                  VRLANCAMENT = (SELECT MAX(VRLANCAMENT)
                                 FROM LANCCONT
                                 WHERE CDEMPRESA  = @V_CDEMPRESA AND
                                       NRLANCCONT = @V_NRLANCCONT);

            IF @V_NRSEQLANC IS NOT NULL BEGIN
               DECLARE C_RATTPCTR CURSOR FOR
               SELECT LC.CDCENTCUST, LC.CDFILIAL, (VRLANCCUST/VRLANCAMENT) AS VRPERATTPCTR
               FROM LANCCCUSTO LC, LANCCONT L
               WHERE LC.CDEMPRESA  = @V_CDEMPRESA  AND
                     LC.NRLANCCONT = @V_NRLANCCONT AND
                     LC.NRSEQLANC  = @V_NRSEQLANC  AND
                     L.CDEMPRESA   = @V_CDEMPRESA  AND
                     L.NRLANCCONT  = @V_NRLANCCONT AND
                     L.NRSEQLANC   = @V_NRSEQLANC;

               OPEN C_RATTPCTR;

               FETCH NEXT FROM C_RATTPCTR INTO @V_RATTPCTR_CDCENTCUST,
                                               @V_RATTPCTR_CDFILIAL,
                                               @V_RATTPCTR_VRPERATTPCTR;

               WHILE (@@FETCH_STATUS = 0) BEGIN

                  SET @V_VRPARCELAS = ROUND(@V_CNTREC_VRATUAREC * @V_RATTPCTR_VRPERATTPCTR, 2);
                  SET @V_VRACUMULADO = @V_VRACUMULADO + @V_VRPARCELAS;

                  IF @V_NRPARCELAS = @V_NRCONTADOR BEGIN
                     IF @V_VRACUMULADO <> @V_CNTREC_VRATUAREC BEGIN
                        SET @V_VRPARCELAS = @V_VRPARCELAS + (@V_CNTREC_VRATUAREC - @V_VRACUMULADO);
                     END;
                  END;

                  INSERT INTO RATCTRECEBER
                     (CDFILIAL, NRLANCTONF, NRSEQVENREC, NRPARCELAREC,
                      CDCENTCUST, CDFIRATCTREC, VRRATCCCTREC)
                  VALUES
                     (@P_CDFILIAL, @P_NRLANCTONF, @V_CNTREC_NRSEQVENREC, @V_CNTREC_NRPARCELAREC,
                      @V_RATTPCTR_CDCENTCUST, @V_RATTPCTR_CDFIRATTPCTR, @V_VRPARCELAS);

                  SET @V_NRCONTADOR = @V_NRCONTADOR + 1;

                  FETCH NEXT FROM C_RATTPCTR INTO @V_RATTPCTR_CDCENTCUST,
                                                  @V_RATTPCTR_CDFILIAL,
                                                  @V_RATTPCTR_VRPERATTPCTR;

               END;
               CLOSE C_RATTPCTR;
               DEALLOCATE C_RATTPCTR;
            END
            ELSE BEGIN
               SELECT @V_NRPARCELAS = COUNT(*)
               FROM RATTPCTR
               WHERE CDTPCTRECEB = @P_CDTPCTRECEB;

               IF @V_NRPARCELAS > 0 BEGIN

                  DECLARE C_RATTPCTR CURSOR FOR
                  SELECT CDTPCTRECEB, CDCENTCUST,
                         ISNULL(LTRIM(REPLACE(CDFIRATTPCTR, '----', @V_CDFILIEMIT)), @V_CDFILIEMIT) AS CDFIRATTPCTR,
                         CDFILIAL, VRPERATTPCTR
                  FROM RATTPCTR
                  WHERE CDTPCTRECEB = @P_CDTPCTRECEB;

                  OPEN C_RATTPCTR;

                  FETCH NEXT FROM C_RATTPCTR INTO @V_RATTPCTR_CDTPCTRECEB, @V_RATTPCTR_CDCENTCUST,
                                                  @V_RATTPCTR_CDFIRATTPCTR, @V_RATTPCTR_CDFILIAL,
                                                  @V_RATTPCTR_VRPERATTPCTR;

                  WHILE (@@FETCH_STATUS = 0) BEGIN

                     SET @V_VRPARCELAS = @V_CNTREC_VRATUAREC * (@V_RATTPCTR_VRPERATTPCTR/100);
                     SET @V_VRACUMULADO = @V_VRACUMULADO + @V_VRPARCELAS;

                     IF @V_NRPARCELAS = @V_NRCONTADOR BEGIN
                        IF @V_VRACUMULADO <> @V_CNTREC_VRATUAREC BEGIN
                           SET @V_VRPARCELAS = @V_VRPARCELAS + (@V_CNTREC_VRATUAREC - @V_VRACUMULADO);
                        END;
                     END;

                     INSERT INTO RATCTRECEBER
                        (CDFILIAL, NRLANCTONF, NRSEQVENREC, NRPARCELAREC,
                         CDCENTCUST, CDFIRATCTREC, VRRATCCCTREC)
                     VALUES
                        (@P_CDFILIAL, @P_NRLANCTONF, @V_CNTREC_NRSEQVENREC, @V_CNTREC_NRPARCELAREC,
                         @V_RATTPCTR_CDCENTCUST, @V_RATTPCTR_CDFIRATTPCTR, @V_VRPARCELAS);

                     SET @V_NRCONTADOR = @V_NRCONTADOR + 1;

                     FETCH NEXT FROM C_RATTPCTR INTO @V_RATTPCTR_CDTPCTRECEB, @V_RATTPCTR_CDCENTCUST,
                                                     @V_RATTPCTR_CDFIRATTPCTR, @V_RATTPCTR_CDFILIAL,
                                                     @V_RATTPCTR_VRPERATTPCTR;

                  END;
                  CLOSE C_RATTPCTR;
                  DEALLOCATE C_RATTPCTR;
               END;
            END;
         END;

         IF ((@V_IDSISTEMA = 'PDV') AND (@V_CNTREC_IDSTATREC = 'P')) BEGIN
            SET @V_NRLANBOLREC = @V_NRLANBOLAUX;
         END;

         SET @V_NRLANBOLREC = RIGHT(REPLICATE('0',10)+CONVERT(VARCHAR,CONVERT(INTEGER,@V_NRLANBOLREC) + 1), 10);
      END;
      FETCH NEXT FROM C_CNTREC INTO @V_CNTREC_NRSEQVENREC, @V_CNTREC_DTATUAVENREC,
                                    @V_CNTREC_DTORIGVENREC, @V_CNTREC_VRATUAREC,
                                    @V_CNTREC_CDFILIBOLREC, @V_CNTREC_NRLANBOLREC,
                                    @V_CNTREC_CDEMPRESA, @V_CNTREC_CDFIMOVFLREC,
                                    @V_CNTREC_DTMOVFLUXO, @V_CNTREC_IDMOVFLUXO,
                                    @V_CNTREC_CDCLASSFINA, @V_CNTREC_VRORIGREC,
                                    @V_CNTREC_NRPARCELAREC, @V_CNTREC_IDSTATREC;
   END;
   CLOSE C_CNTREC;
   DEALLOCATE C_CNTREC;

   SELECT @V_NRPARCELAS = COUNT(*), @V_VRTOTACONT = SUM(VRATUAREC)
   FROM CONTARECEBER
   WHERE CDFILIAL   = @P_CDFILIAL AND
         NRLANCTONF = @P_NRLANCTONF;

   DECLARE C_AJUSTE CURSOR FOR
   SELECT ISNULL(SUM(IT.VRTOTIMPONF),0) AS VRTOTIMPONF, I.CDAJUCTREC
   FROM IMPOSNFTOT IT, IMPOSTO I
   WHERE IT.CDFILIAL    = @P_CDFILIAL   AND
         IT.NRLANCTONF  = @P_NRLANCTONF AND
         IT.CDIMPOSTO   = I.CDIMPOSTO   AND
         I.IDTRATIMPO   = 'R'           AND
         I.IDDESCRFONTE = 'A'
   GROUP BY I.CDAJUCTREC;

   OPEN C_AJUSTE;

   FETCH NEXT FROM C_AJUSTE INTO @V_AJUSTE_VRTOTIMPONF, @V_AJUSTE_CDAJUCTREC;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF @V_AJUSTE_VRTOTIMPONF > 0 BEGIN

         SET @V_NRCONTADOR = 1;
         SET @V_VRACUMULADO = @V_AJUSTE_VRTOTIMPONF;

         DECLARE C_CNTREC CURSOR FOR
         SELECT NRSEQVENREC, DTATUAVENREC, VRATUAREC,
                CDFILIBOLREC, NRLANBOLREC, NRLANCTODUP,
                CDEMPRESA, NRPARCELAREC,   CDCLASSFINA,
                CDFIMOVFLREC
         FROM CONTARECEBER
         WHERE CDFILIAL   = @P_CDFILIAL AND
               NRLANCTONF = @P_NRLANCTONF
         ORDER BY NRSEQVENREC;

         OPEN C_CNTREC;

         FETCH NEXT FROM C_CNTREC INTO @V_CNTREC_NRSEQVENREC, @V_CNTREC_DTATUAVENREC,
                                       @V_CNTREC_VRATUAREC, @V_CNTREC_CDFILIBOLREC,
                                       @V_CNTREC_NRLANBOLREC, @V_CNTREC_NRLANCTODUP,
                                       @V_CNTREC_CDEMPRESA, @V_CNTREC_NRPARCELAREC,
                                       @V_CNTREC_CDCLASSFINA, @V_CNTREC_CDFIMOVFLREC;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            IF @V_NRPARCELAS = @V_NRCONTADOR BEGIN
               SET @V_VRAJUSTEBO = @V_VRACUMULADO;
            END
            ELSE BEGIN
               SET @V_VRAJUSTEBO  = ROUND((@V_AJUSTE_VRTOTIMPONF/@V_VRTOTACONT) * @V_CNTREC_VRATUAREC, 2);
               SET @V_VRACUMULADO = @V_VRACUMULADO - @V_VRAJUSTEBO;
            END;

            IF @V_CNTREC_CDCLASSFINA IS NULL BEGIN
               SET @V_CDCLASSAJUS = @V_CDCLASSFINA;
            END
            ELSE BEGIN
               SET @V_CDCLASSAJUS = @V_CNTREC_CDCLASSFINA;
            END;

            IF @V_CNTREC_CDFIMOVFLREC IS NULL BEGIN
               SET @V_CDFIMFLUXO = @V_CDFILIEMIT;
            END
            ELSE BEGIN
               SET @V_CDFIMFLUXO = @V_CNTREC_CDFIMOVFLREC;
            END;

            IF @V_CNTREC_NRLANCTODUP IS NULL BEGIN
               SET @V_MULT = @V_VRAJUSTEBO * -1;
               EXEC ATUALIZA_FLUXO_DE_CAIXA @V_CNTREC_CDEMPRESA,
                                            @V_CDFIMFLUXO,
                                            @V_CNTREC_DTATUAVENREC,
                                            'E',
                                            @V_CDCLASSAJUS,
                                            @V_MULT,
                                            0;

               INSERT INTO AJBOLREC
                  (CDFILIAL, NRLANBOLREC, CDAJUCTREC, VRAJBOLREC)
               VALUES
                  (@P_CDFILILANC, @V_CNTREC_NRLANBOLREC, @V_AJUSTE_CDAJUCTREC, @V_VRAJUSTEBO);

               INSERT INTO MOVFXAJBOLR
                  (CDFILIBOLREC, NRLANBOLREC, CDAJUCTREC,
                   CDCLASSFINA,  CDEMPRESA,   CDFILIAL,
                   DTMOVFLUXO,   IDMOVFLUXO,  VRFXAJBOLREC)
               VALUES
                  (@P_CDFILILANC,  @V_CNTREC_NRLANBOLREC, @V_AJUSTE_CDAJUCTREC,
                   @V_CDCLASSAJUS, @V_CNTREC_CDEMPRESA,   @V_CDFIMFLUXO,
                   @V_CNTREC_DTATUAVENREC, 'E', @V_VRAJUSTEBO);

               UPDATE BOLETRECEBER
               SET VRFINALBREC   = ROUND((VRBOLREC - @V_VRAJUSTEBO),2)
               WHERE CDFILIAL    = @P_CDFILILANC  AND
                     NRLANBOLREC = @V_CNTREC_NRLANBOLREC;
            END;
            SET @V_NRCONTADOR = @V_NRCONTADOR + 1;

            FETCH NEXT FROM C_CNTREC INTO @V_CNTREC_NRSEQVENREC, @V_CNTREC_DTATUAVENREC,
                                          @V_CNTREC_VRATUAREC, @V_CNTREC_CDFILIBOLREC,
                                          @V_CNTREC_NRLANBOLREC, @V_CNTREC_NRLANCTODUP,
                                          @V_CNTREC_CDEMPRESA, @V_CNTREC_NRPARCELAREC,
                                          @V_CNTREC_CDCLASSFINA, @V_CNTREC_CDFIMOVFLREC;

         END;
         CLOSE C_CNTREC;
         DEALLOCATE C_CNTREC;
      END;
      FETCH NEXT FROM C_AJUSTE INTO @V_AJUSTE_VRTOTIMPONF, @V_AJUSTE_CDAJUCTREC;
   END;
   CLOSE C_AJUSTE;
   DEALLOCATE C_AJUSTE;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GERA_BOLETOS','5.07.011';
GO

